using RMYY_CallCenter_Api.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RMYY_CallCenter_Api.Dal
{
    /// <summary>
    /// 数据访问类:T_Car_Message
    /// </summary>
    public partial class T_Car_Message
    {
        public T_Car_Message()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_Id)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Car_Message");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(RMYY_CallCenter_Api.Model.T_Car_Message model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Car_Message(");
            strSql.Append("F_CarName,F_CarType,F_CarDeptId,F_Responser,F_Phon,F_Remark,F_CreateTime,F_State,F_DeptName,F_ResponserName)");
            strSql.Append(" values (");
            strSql.Append("@F_CarName,@F_CarType,@F_CarDeptId,@F_Responser,@F_Phon,@F_Remark,@F_CreateTime,@F_State,@F_DeptName,@F_ResponserName)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_CarName", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_CarType", SqlDbType.Int,4),
                    new SqlParameter("@F_CarDeptId", SqlDbType.Int,4),
                    new SqlParameter("@F_Responser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_Phon", SqlDbType.VarChar,20),
                    new SqlParameter("@F_Remark", SqlDbType.Text),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_DeptName", SqlDbType.VarChar,50),
                    new SqlParameter("@F_ResponserName", SqlDbType.VarChar,50)};
            parameters[0].Value = model.F_CarName;
            parameters[1].Value = model.F_CarType;
            parameters[2].Value = model.F_CarDeptId;
            parameters[3].Value = model.F_Responser;
            parameters[4].Value = model.F_Phon;
            parameters[5].Value = model.F_Remark;
            parameters[6].Value = model.F_CreateTime;
            parameters[7].Value = model.F_State;
            parameters[8].Value = model.F_DeptName;
            parameters[9].Value = model.F_ResponserName;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(RMYY_CallCenter_Api.Model.T_Car_Message model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Car_Message set ");
            strSql.Append("F_CarName=@F_CarName,");
            strSql.Append("F_CarType=@F_CarType,");
            strSql.Append("F_CarDeptId=@F_CarDeptId,");
            strSql.Append("F_Responser=@F_Responser,");
            strSql.Append("F_Phon=@F_Phon,");
            strSql.Append("F_Remark=@F_Remark,");
            strSql.Append("F_CreateTime=@F_CreateTime,");
            strSql.Append("F_State=@F_State,");
            strSql.Append("F_DeptName=@F_DeptName,");
            strSql.Append("F_ResponserName=@F_ResponserName");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_CarName", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_CarType", SqlDbType.Int,4),
                    new SqlParameter("@F_CarDeptId", SqlDbType.Int,4),
                    new SqlParameter("@F_Responser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_Phon", SqlDbType.VarChar,20),
                    new SqlParameter("@F_Remark", SqlDbType.Text),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_DeptName", SqlDbType.VarChar,50),
                    new SqlParameter("@F_ResponserName", SqlDbType.VarChar,50),
                    new SqlParameter("@F_Id", SqlDbType.Int,4)};
            parameters[0].Value = model.F_CarName;
            parameters[1].Value = model.F_CarType;
            parameters[2].Value = model.F_CarDeptId;
            parameters[3].Value = model.F_Responser;
            parameters[4].Value = model.F_Phon;
            parameters[5].Value = model.F_Remark;
            parameters[6].Value = model.F_CreateTime;
            parameters[7].Value = model.F_State;
            parameters[8].Value = model.F_DeptName;
            parameters[9].Value = model.F_ResponserName;
            parameters[10].Value = model.F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Car_Message ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Car_Message ");
            strSql.Append(" where F_Id in (" + F_Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public RMYY_CallCenter_Api.Model.T_Car_Message GetModel(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Id,F_CarName,F_CarType,F_CarDeptId,F_Responser,F_Phon,F_Remark,F_CreateTime,F_State,F_DeptName,F_ResponserName from T_Car_Message ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            RMYY_CallCenter_Api.Model.T_Car_Message model = new RMYY_CallCenter_Api.Model.T_Car_Message();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public RMYY_CallCenter_Api.Model.T_Car_Message DataRowToModel(DataRow row)
        {
            RMYY_CallCenter_Api.Model.T_Car_Message model = new RMYY_CallCenter_Api.Model.T_Car_Message();
            if (row != null)
            {
                if (row["F_Id"] != null && row["F_Id"].ToString() != "")
                {
                    model.F_Id = int.Parse(row["F_Id"].ToString());
                }
                if (row["F_CarName"] != null)
                {
                    model.F_CarName = row["F_CarName"].ToString();
                }
                if (row["F_CarType"] != null && row["F_CarType"].ToString() != "")
                {
                    model.F_CarType = int.Parse(row["F_CarType"].ToString());
                }
                if (row["F_CarDeptId"] != null && row["F_CarDeptId"].ToString() != "")
                {
                    model.F_CarDeptId = int.Parse(row["F_CarDeptId"].ToString());
                }
                if (row["F_Responser"] != null)
                {
                    model.F_Responser = row["F_Responser"].ToString();
                }
                if (row["F_Phon"] != null)
                {
                    model.F_Phon = row["F_Phon"].ToString();
                }
                if (row["F_Remark"] != null)
                {
                    model.F_Remark = row["F_Remark"].ToString();
                }
                if (row["F_CreateTime"] != null && row["F_CreateTime"].ToString() != "")
                {
                    model.F_CreateTime = DateTime.Parse(row["F_CreateTime"].ToString());
                }
                if (row["F_State"] != null && row["F_State"].ToString() != "")
                {
                    model.F_State = int.Parse(row["F_State"].ToString());
                }
                if (row["F_DeptName"] != null)
                {
                    model.F_DeptName = row["F_DeptName"].ToString();
                }
                if (row["F_ResponserName"] != null)
                {
                    model.F_ResponserName = row["F_ResponserName"].ToString();
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_Id,F_CarName,F_CarType,F_CarDeptId,F_Responser,F_Phon,F_Remark,F_CreateTime,F_State,F_DeptName,F_ResponserName ");
            strSql.Append(" FROM T_Car_Message ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_Id,F_CarName,F_CarType,F_CarDeptId,F_Responser,F_Phon,F_Remark,F_CreateTime,F_State,F_DeptName,F_ResponserName ");
            strSql.Append(" FROM T_Car_Message ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Car_Message ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Car_Message T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Car_Message";
			parameters[1].Value = "F_Id";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
